# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

##--------------------------------------#######
#                 Fenetres                              #
##--------------------------------------#######
#    WxGeometrie
#    Dynamic geometry, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2007  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#version unicode


# importation des librairies classiques
from LIB import *

####################################################################################################

# Historique des commandes


class FenHistorique(wx.MiniFrame):
    def __init__(self, parent):
        wx.MiniFrame.__init__(self, parent, -1, u"Historique des commandes")
        self.parent = parent
        self.historique = self.parent.onglet_actuel.historique

        self.texte = wx.TextCtrl(self, -1, self.historique.contenu(), size=(300, 10), style=wx.TE_MULTILINE)
        self.texte.Bind(wx.EVT_CHAR, self.EvtChar)
        self.texte.SetInsertionPointEnd()
        self.texte.SetFocus()
        
        
        tb = self.CreateToolBar( wx.TB_HORIZONTAL
                                 | wx.NO_BORDER
                                 | wx.TB_FLAT
                                 | wx.TB_TEXT )
        tb.AddSeparator()
        tb.AddSeparator()
        self.a = wx.Button(tb, -1, u"Executer - F5")
        tb.AddControl(self.a)
        tb.AddSeparator()
        tb.AddSeparator()
        self.b = wx.Button(tb, -1, u"Annuler - ESC")
        tb.AddControl(self.b)
        tb.Realize()
        
        self.Bind(wx.EVT_BUTTON, self.executer, self.a)
        self.Bind(wx.EVT_BUTTON, self.fermer, self.b)
        
        
    def EvtChar(self, event):
        key = event.GetKeyCode()
        if key == 27: self.fermer()
        elif key == 346: self.executer(event)
        else : event.Skip()
        
    def fermer(self, event = None):
        self.Close(True)
    
    def executer(self, event = None):  # on initialise la session et on recommence
        for feuille in self.parent.onglet_actuel.feuilles.keys():
            self.parent.onglet_actuel.fermer_feuille(feuille)
        self.parent.onglet_actuel.numero_feuille = 0

        if param.historique_log:    self.historique.stocker()
        self.historique.initialiser_historique()
        for commande in self.texte.GetValue().split("\n"):
            self.historique.executer(commande)
        self.fermer()
