# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

import re
import os
import shutil

#~ liste = [nom[:-3] for nom in os.listdir(".") if nom.endswith('.py') and not nom.endswith('_modifie.py') and "_" not in nom and nom[:-3] not in ("objet","maj","ALL","feuille","tests")]
liste = ['labels', 'variables', 'cercles', 'widgets', 'points', 'transformations', 'angles', 'vecteurs', 'intersections', 'wxwidgets', 'courbes', 'textes', 'lignes', 'polygones']

suffixe = ""
#~ suffixe = "_modifie"

os.chdir("/home/nico/version_0.113/geolib")

for nom in liste:
    shutil.copy("/home/nico/version_0.113/geolib6_alpha1/" + nom + ".py", ".")


###############################

def advanced_split(main_string, separator, keep_empty_str = False, symbols = "([{}])"):
    u"""Dcoupe la chaine "main_string" de manire intelligente, 
    en ignorant les sparateurs compris dans un groupe entre parenthses, crochets, accolades, guillemets.
    Attention, separateur ne peut donc pas tre une parenthse, un crochet, une accolade ou un guillemet !
    Par dfaut, supprime galement les chaines vides."""
    in_string = False # est-on dans une chaine ?
    in_string_sep = "'" # caractere encadrant la chaine (" ou ')
    parentheses = 0 # tient le compte des parentheses ouvertes non fermees
    crochets = 0 # idem pour les crochets
    accolades = 0 # idem
    coupures = [-1] # endroits ou il faudra couper la chaine
    for i in xrange(len(main_string)):
        a = main_string[i]
        if a in ("'", '"'):
            if in_string:
                if in_string_sep == a: # attention, il y a 2 indicateurs de chaine (" et ')
                    in_string = False
            else:
                in_string = True
                in_string_sep = a
        elif a in symbols:
            if a == "(" and not in_string:
                parentheses += 1
            elif a == ")" and not in_string:
                parentheses -= 1
            elif a == "[" and not in_string:
                crochets += 1
            elif a == "]" and not in_string:
                crochets -= 1
            elif a == "{" and not in_string:
                accolades += 1
            elif a == "}" and not in_string:
                accolades -= 1
        elif a == separator and not (in_string or parentheses or crochets or accolades) :
            coupures.append(i)
    coupures.append(None)
    # chaine[i:None] retourne la fin de chaine
    
    return [main_string[i+1:j] for i, j in zip(coupures[:-1], coupures[1:]) if main_string[i+1:j] or keep_empty_str]



###############################



def maj(fichier):
    
    f = open(fichier + ".py","r")
    t = f.read()
    f.close()
    classes = t.split("\nclass ")
    t = "\n\n\n".join(traiter_classe(classe) for classe in classes)[6:]
    f = open(fichier + suffixe + ".py","w")
    f.write(t)
    f.close()
    
    
    
def traiter_classe(classe):
    classe = ("class " + classe).split("\n")
    newclasse = []
    arguments = ()
    for ligne in classe:
        if ligne.strip().startswith("self._initialiser"):
            print ligne
            ligne = advanced_split(ligne.strip()[18:-1], ",")
            print ligne
            arguments = [arg.split("=") for arg in ligne]
            for i in xrange(len(arguments)):
                arguments[i][0] = arguments[i][0].strip()
                arguments[i][1] = arguments[i][1].strip(" ()")
                arguments[i][1] = arguments[i][1].replace("ALL.", "")
            break
    
    for ligne in classe:
        if ligne.startswith("    def __init__(self,"):
            for arg, type in arguments:
                if type[0] == "[":
                    type = type[1:-1]
                    newclasse.append('    %(arg)s = __%(arg)s = Arguments("%(type)s")' %locals())
                else:
                    newclasse.append('    %(arg)s = __%(arg)s = Argument("%(type)s")' %locals())
            if arguments:
                newclasse.append("")
                    
        if ligne.startswith("        self.__args = GestionnaireArguments()"):
            for arg, type in arguments:
                if type[0] == "[":
                    newclasse.append("        self.__%(arg)s = %(arg)s = (Ref(obj) for obj in %(arg)s)" %locals())
                else:
                    newclasse.append("        self.__%(arg)s = %(arg)s = Ref(%(arg)s)" %locals())
            
        elif not(   ligne.startswith("        self._initialiser") 
                    or re.match("        self[.]__args[.][_A-Za-z][_A-Za-z0-9]* = [_A-Za-z][_A-Za-z0-9]* = Argument[(]", ligne)
                    or re.match("        self[.]__args[.][_A-Za-z][_A-Za-z0-9]* = [_A-Za-z][_A-Za-z0-9]* = CTuple[(]Argument[(]", ligne)
                ):
            newclasse.append(ligne.replace("__args.", "__"))
            
    
    return "\n".join(newclasse)
    
for fichier in liste:
    maj(fichier)
            
                    
