#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

##--------------------------------------#######
#   Mathlib 2 (sympy powered) #
##--------------------------------------#######
#WxGeometrie
#Dynamic geometry, graph plotter, and more for french mathematic teachers.
#Copyright (C) 2005-2007  Nicolas Pourcelot
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# version unicode

## Les fonctions qui doivent tre accessibles par l'utilisateur final
## "from end_user_functions import *" doit donner un rsultat propre.
__classement__ = {
    u"Algbre": [], 
    u"Analyse": [], 
    u"Symboles": [],  
    u"Arithmtique": [],  
}

from universal_functions import *

from custom_functions import derivee


from sympy_functions import expand
developpe = expand
__classement__[u"Algbre"].append((u"Dveloppe", "developpe", u"Dvelopper une expression."))

from sympy_functions import factor
factorise = factor
__classement__[u"Algbre"].append((u"Factorise", "factorise", u"Factoriser une expression."))

from sympy_functions import cfactor
cfactorise = cfactor
__classement__[u"Algbre"].append((u"Factorise dans C", "cfactorise", u"Factoriser une expression dans le corps des complexes."))

from sympy_functions import evalf
evalue = evalf
__classement__[u"Algbre"].append((u"value", "evalue", u"Calculer une valeur approche."))

from sympy_functions import sum
somme = sum
__classement__[u"Algbre"].append((u"Somme", "somme", u"Calculer une somme."))

from sympy_functions import product
produit = product
__classement__[u"Algbre"].append((u"Produit", "produit", u"Calculer un produit."))

from custom_functions import resoudre
solve = resoudre
__classement__[u"Algbre"].append((u"Rsoudre", "resoudre", u"Rsoudre une (in)quation ou un systme."))

from sympy import isprime
premier = isprime
__classement__[u"Arithmtique"].append((u"Premier ?", "premier", u"Tester si un nombre est premier."))

from sympy_functions import divisors
diviseurs = divisors
__classement__[u"Arithmtique"].append((u"Diviseurs", "diviseurs", u"Chercher les diviseurs d'un nombre."))

# Alias
facteurs = factors = factor
__classement__[u"Arithmtique"].append((u"Facteurs premiers", "facteurs", u"Dcomposer un nombre en facteurs premiers."))

from custom_functions import pgcd
gcd = pgcd
__classement__[u"Arithmtique"].append((u"PGCD", "pgcd", u"Calculer le PGCD de plusieurs entiers."))

from custom_functions import ppcm
lcm = ppcm
__classement__[u"Arithmtique"].append((u"PPCM", "ppcm", u"Calculer le PPCM de plusieurs entiers."))

from sympy import factorial
factoriel = factorial
__classement__[u"Arithmtique"].append((u"Factoriel", "factoriel", u"factoriel(n) vaut 1*2*3*4*5*...*n."))

from sympy import ff 
arrangements = nAr = nA = ff
__classement__[u"Arithmtique"].append((u"Arrangements", "nAr", u"Nombre d'arrangements."))

from sympy import binomial
combinaisons = binome = nCr = nC = binomial
__classement__[u"Arithmtique"].append((u"Combinaisons", "nCr", u"Nombre de combinaisons."))

from sympy_functions import limit
lim = limite = limit
__classement__[u"Analyse"].append((u"Limite", "limite", u"Calculer une limite. Ex: 'limite(1/x,x,0+)', 'limite(x^2,x,-oo)'"))

from sympy_functions import diff
derive = diff
__classement__[u"Analyse"].append((u"Drive", "derive", u"Driver une expression. Ex: 'derive(2x+7,x)' et 'derive(2x+7,x,2)' (drive seconde)"))

from sympy_functions import integrate
integre = integrate
__classement__[u"Analyse"].append((u"Intgre", "integre", u"Intgrer une expression. Ex: 'integre(x+1,x)' et 'integre(x+1,(x,-1,1))"))

from sympy_functions import series
taylor = series
__classement__[u"Analyse"].append((u"Taylor", "taylor", u"Dveloppement limit. Ex: 'series(cos(x),x,0,5)'"))

from sympy import pi
__classement__[u"Symboles"].append((u"pi", "pi", u"Le nombre pi."))

from sympy import oo
__classement__[u"Symboles"].append((u"oo", "oo", u"L'infini positif."))

from sympy import E
e = E
__classement__[u"Symboles"].append((u"e", "e", u"Le nombre e = exp(1)."))

from sympy import I
i = I
__classement__[u"Symboles"].append((u"i", "i", u"Le nombre imaginaire i."))






#~ class Exp1_bis(sympy.core.numbers.Exp1):
    #~ def tostr(self, level=0):
        #~ return 'e'
        
#~ e = Exp1_bis()

#~ del Exp1_bis

#~ class ImaginaryUnit_bis(sympy.core.numbers.ImaginaryUnit):
    #~ def tostr(self, level=0):
        #~ return 'i'
        
#~ i = ImaginaryUnit_bis()

#~ del ImaginaryUnit_bis

    
    
